
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Web_search_resultsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const web_search_results = await db.web_search_results.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        url: data.url
        ||
        null
            ,
            
        snippet: data.snippet
        ||
        null
            ,
            
        fetched_at: data.fetched_at
        ||
        null
            ,
            
        rank: data.rank
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await web_search_results.setQuery( data.query || null, {
            transaction,
        });
        
        await web_search_results.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return web_search_results;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const web_search_resultsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                url: item.url
            ||
            null
            ,
            
                snippet: item.snippet
            ||
            null
            ,
            
                fetched_at: item.fetched_at
            ||
            null
            ,
            
                rank: item.rank
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const web_search_results = await db.web_search_results.bulkCreate(web_search_resultsData, { transaction });

        // For each item created, replace relation files
        

        return web_search_results;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const web_search_results = await db.web_search_results.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.url !== undefined) updatePayload.url = data.url;
        
        
        if (data.snippet !== undefined) updatePayload.snippet = data.snippet;
        
        
        if (data.fetched_at !== undefined) updatePayload.fetched_at = data.fetched_at;
        
        
        if (data.rank !== undefined) updatePayload.rank = data.rank;
        
        
        updatePayload.updatedById = currentUser.id;

        await web_search_results.update(updatePayload, {transaction});

        
        
        if (data.query !== undefined) {
            await web_search_results.setQuery(
              
              data.query,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await web_search_results.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return web_search_results;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const web_search_results = await db.web_search_results.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of web_search_results) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of web_search_results) {
                await record.destroy({transaction});
            }
        });


        return web_search_results;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const web_search_results = await db.web_search_results.findByPk(id, options);

        await web_search_results.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await web_search_results.destroy({
            transaction
        });

        return web_search_results;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const web_search_results = await db.web_search_results.findOne(
            { where },
            { transaction },
        );

        if (!web_search_results) {
            return web_search_results;
        }

        const output = web_search_results.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.query = await web_search_results.getQuery({
            transaction
        });
        
        
        output.organizations = await web_search_results.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.web_search_queries,
        as: 'query',
        
        where: filter.query ? {
          [Op.or]: [
            { id: { [Op.in]: filter.query.split('|').map(term => Utils.uuid(term)) } },
            {
              query_text: {
                [Op.or]: filter.query.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'web_search_results',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'web_search_results',
                        'url',
                        filter.url,
                    ),
                };
            }
            
            if (filter.snippet) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'web_search_results',
                        'snippet',
                        filter.snippet,
                    ),
                };
            }
            

            
            

            
            if (filter.fetched_atRange) {
                const [start, end] = filter.fetched_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    fetched_at: {
                    ...where.fetched_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    fetched_at: {
                    ...where.fetched_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rankRange) {
                const [start, end] = filter.rankRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rank: {
                    ...where.rank,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rank: {
                    ...where.rank,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.web_search_results.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'web_search_results',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.web_search_results.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

